C  CUTL5  MOC UTILITY SUBROUTINES
C
C  SMOC5Z    SET ARRAY TO CONSTANT VALUE
C*************************************************************************
C
      SUBROUTINE SMOC5Z(ARRAY,NSCOL,NSROW,NSLAY,VALUE)
C
C*************************************************************************
C
      DIMENSION ARRAY(NSCOL,NSROW,NSLAY)
C
      DO 10 KS=1,NSLAY
      DO 10 IS=1,NSROW
      DO 10 JS=1,NSCOL
      ARRAY(JS,IS,KS)=VALUE
10    CONTINUE
C
      RETURN
      END
C
C***************************************************************
C
      SUBROUTINE SMOC6O(INUNIT,INMOC,IOUTS,JUNIT,DUNIT,MOCTYPE)
C
C-----from VERSION 0818 15JULY1993 SBAS5O
C     ******************************************************************
C     OPEN FILES.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      DIMENSION JUNIT(40)
      CHARACTER*4 DUNIT(40)
      CHARACTER*80 LINE
      CHARACTER*11 FMTARG
C     ---------------------------------------------------------------
C
C1------INITIALIZE CONSTANTS.  ILIST IS SET TO 1 ONCE THE LISTING
C1------FILE HAS BEEN OPENED; UNTIL THEN ERROR MESSAGES ARE WRITTEN
C1------ TO "*" UNIT.
      ILIST=0
      IOUTS=0
      INMOC=0
      MOCTYPE=0
      DO 5 I=1,40
      JUNIT(I)=0
5     CONTINUE

C
C2------READ A LINE; IGNORE BLANK LINES AND PRINT COMMENT LINES.
10    READ(INUNIT,'(A)',END=1000) LINE
      IF(LINE.EQ.' ') GO TO 10
      IF(LINE(1:1).EQ.'#') THEN
        IF(ILIST.NE.0) WRITE(IOUTS,'(A)') LINE
        GO TO 10
      END IF
C
C3------DECODE THE FILE TYPE AND UNIT NUMBER.
      LLOC=1
      CALL URWORD(LINE,LLOC,ITYP1,ITYP2,1,N,R,IOUTS,INUNIT)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IU,R,IOUTS,INUNIT)
C
C4------CHECK FOR A VALID FILE TYPE.
      FMTARG='FORMATTED'
C
C4A-----FIRST ENTRY MUST BE FILE-TYPE "CLST".
      IF(ILIST.EQ.0) THEN
         IF(LINE(ITYP1:ITYP2).NE.'CLST') THEN
            WRITE(*,*) ' FIRST ENTRY IN MOC NAME FILE MUST BE "CLST".'
            STOP
         END IF
         IOUTS=IU
C
C4B-----CHECK FOR "MOC" FILE TYPE.
      ELSEIF(LINE(ITYP1:ITYP2).EQ.'MOC'.AND.MOCTYPE.EQ.0) THEN
         INMOC=IU
         MOCTYPE=1
      ELSEIF(LINE(ITYP1:ITYP2).EQ.'MOCIMP'.AND.MOCTYPE.EQ.0) THEN
         INMOC=IU
         MOCTYPE=2
      ELSEIF(LINE(ITYP1:ITYP2).EQ.'ELLAM'.AND.MOCTYPE.EQ.0) THEN
         INMOC=IU
         MOCTYPE=3
C
C4C-----CHECK FOR "UNFORMATTED" FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA(BINARY)') THEN
         FMTARG='UNFORMATTED'
C
C4D-----CHECK FOR "FORMATTED FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA') THEN
         FMTARG='FORMATTED'
C
C4E-----CHECK FOR MAJOR OPTIONS.
      ELSE
         DO 20 I=1,40
            IF(LINE(ITYP1:ITYP2).EQ.DUNIT(I)) THEN
               JUNIT(I)=IU
C       CHECK FOR BINARY FILE
               IF(I.EQ.3.OR.I.EQ.5.OR.I.EQ.7) 
     *           FMTARG='UNFORMATTED'
               GO TO 30
            END IF
20       CONTINUE
         WRITE(IOUTS,21) LINE(ITYP1:ITYP2)
21       FORMAT(1X,'ILLEGAL FILE TYPE IN NAME FILE: ',A)
         STOP
30       CONTINUE
      END IF
C
C5------DETERMINE FILE NAME AND THE ACCESS METHOD (DIRECT OR
C5------SEQUENTIAL).  WRITE THE FILE NAME IF THE FILE IS NOT THE
C5------LISTING FILE.  THEN OPEN THE FILE.
      CALL URWORD(LINE,LLOC,INAM1,INAM2,0,N,R,IOUTS,INUNIT)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUTS,INUNIT)
      IF(LINE(ISTART:ISTOP).EQ.'DIRECT') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IRECL,R,IOUTS,INUNIT)
         IF(ILIST.NE.0) WRITE(IOUTS,35) LINE(INAM1:INAM2),
     1        LINE(ITYP1:ITYP2),IU,IRECL
35       FORMAT(1X,/1X,'OPENING ',A,/
     1     1X,'FILE TYPE: ',A,'   UNIT',I4,'   DIRECT ACCESS',I10)
         OPEN(UNIT=IU,FILE=LINE(INAM1:INAM2),FORM=FMTARG,
     1         ACCESS='DIRECT',RECL=IRECL)
      ELSE
         IF(ILIST.NE.0) WRITE(IOUTS,36) LINE(INAM1:INAM2),
     1        LINE(ITYP1:ITYP2),IU
36       FORMAT(1X,/1X,'OPENING ',A,/
     1     1X,'FILE TYPE: ',A,'   UNIT',I4)
         OPEN(UNIT=IU,FILE=LINE(INAM1:INAM2),FORM=FMTARG,
     1         ACCESS='SEQUENTIAL')
      END IF
C
C6------IF THE OPENED FILE IS THE LISTING FILE, WRITE ITS NAME.
C6------GO BACK AND READ NEXT RECORD.
C1------IDENTIFY MOC PACKAGE.
      IF(ILIST.EQ.0) WRITE(IOUTS,1)
    1 FORMAT(1H ,//
     *'              U.S. GEOLOGICAL SURVEY'/
     *' METHOD-OF-CHARACTERISTICS SOLUTE-TRANSPORT MODEL'/
     *'         MOC3D (Version 3.52) January 2004'///
     *' MOC BASIC INPUT READ FROM UNIT',I4)
      IF(ILIST.EQ.0) WRITE(IOUTS,37) LINE(INAM1:INAM2),IU
37    FORMAT(1X,'LISTING FILE: ',A,3X,'UNIT',I4)
      ILIST=1
      GO TO 10
C
C7------END OF NAME FILE.  RETURN PROVIDED THAT LISTING FILE AND BAS
C7------FILES HAVE BEEN OPENED.
1000  IF(ILIST.EQ.0) THEN
         WRITE(*,*) ' MOC NAME FILE IS EMPTY.'
         STOP
      ELSE IF(INMOC.EQ.0) THEN
         WRITE(*,*) ' MAIN MOC INPUT FILE HAS NOT BEEN OPENED.'
         STOP
      END IF
C8------RETURN PROVIDED THAT ELLAM NOT BEING USED WITH DP,DK,AGE
      IF(MOCTYPE.EQ.3) THEN
        IF(JUNIT(9).GT.0) THEN
          WRITE(IOUTS,*) ' ELLAM AND AGE PACKAGE ARE NOT COMPATIBLE.'
          STOP
        ENDIF
        IF(JUNIT(10).GT.0) THEN
          WRITE(IOUTS,*) ' ELLAM AND DP PACKAGE ARE NOT COMPATIBLE.'
          STOP
        ENDIF
        IF(JUNIT(11).GT.0) THEN
          WRITE(IOUTS,*) ' ELLAM AND DK PACKAGE ARE NOT COMPATIBLE.'
          STOP
        ENDIF
      END IF
      CLOSE(UNIT=INUNIT)
      RETURN
C
      END
C
C***************************************************************
C
      SUBROUTINE SMOC6C(CONC,THCK,SBVL,SRCDCY,
     *    KSTP,NSTP,KPER,NPER,IMOV,NMOV,TIMV,
     *    DELR,DELC,NCOL,NROW,NLAY,
     *    NSCOL,NSROW,NSLAY,IOUTS,JUNIT,PERTIM,TOTIM,SUMTCH,
     *    NPNTCL,ICONFM,ICONLY,
     2 IDKZO,IDKFO,IDKZS,IDKFS,
     3 IDPZO,IDPFO)
C
C-----from VERSION 1653 15MAY1987 SBAS1H
C     *******************************************************
C     PRINT AND RECORD CONCS
C     *******************************************************
C
C        SPECIFICATIONS
C     -------------------------------------------------------
      DIMENSION CONC(NSCOL,NSROW,NSLAY),SBVL(4,40),
     *  JUNIT(40),THCK(NSCOL,NSROW,NSLAY),
     *  DELR(NCOL),DELC(NROW)
C
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C     -------------------------------------------------------
C CHECK FLAGS FOR OUTPUT
      IPRNT=0
      COLPRT=0
      IF (NPNTCL.EQ.0.AND.KPER.EQ.NPER.AND.KSTP.EQ.NSTP.
     *AND.IMOV.EQ.NMOV) IPRNT=1
      IF (NPNTCL.EQ.-2.AND.KSTP.EQ.NSTP.AND.IMOV.EQ.NMOV) IPRNT=1
      IF (NPNTCL.EQ.-1.AND.IMOV.EQ.NMOV) IPRNT=1
      IF(NPNTCL.GE.1) THEN
         IF(MOD(IMOV,NPNTCL).EQ.0) IPRNT=1
      ENDIF
      IF (KPER.EQ.NPER.AND.KSTP.EQ.NSTP.AND.IMOV.EQ.NMOV) IPRNT=1
C INITIAL CONDITION
      IF(IMOV.EQ.0) IPRNT=1
C SKIP IF NO OUTPUT
      IF (IPRNT.EQ.0) RETURN
C FOR EACH LAYER: PRINT CONC IF REQUESTED.
      DO 80 KS=1,NSLAY
      KKS=KS
      KK=KS+ISLAY1-1
C
       IF(JUNIT(2).LE.0.AND.JUNIT(3).LE.0) THEN
C PRINT TO MAIN OUTPUT FILE
         WRITE(IOUTS,49) KS,KK
  49  FORMAT(//,'     SUBGRID LAYER ',I3,' = MODFLOW LAYER ',I3)
         IF(ICONFM.LT.0) CALL ULAPRS(CONC(1,1,KKS),'CONCENTRATIONS  ',
     *       KSTP,KPER,NSCOL,NSROW,KK,-ICONFM,IOUTS)
         IF(ICONFM.GE.0) CALL ULAPRW(CONC(1,1,KKS),'CONCENTRATIONS  ',
     *       KSTP,KPER,NSCOL,NSROW,KK,ICONFM,IOUTS)
       ELSE
C PRINT TO SEPARATE TEXT FILE
         IF(KS.EQ.1.AND.IMOV.EQ.0) THEN
            IF(ICONFM.GE.0) THEN
                    IF(JUNIT(2).GT.0) WRITE(IOUTS,51) JUNIT(2)
            ELSE
              IF(JUNIT(2).GT.0) WRITE(IOUTS,52) JUNIT(2)
            ENDIF
         ENDIF
  51  FORMAT('CONCENTRATION DATA WILL BE SAVED ON UNIT ',I3,
     *' IN MATRIX FORMAT')
  52  FORMAT('CONCENTRATION DATA WILL BE SAVED ON UNIT ',I3,
     *' IN X,Y,Z,CONC FORMAT')
C
         IF(JUNIT(2).GT.0) THEN
         IF(ICONFM.GE.0) THEN
C PRINT IN MATRIX FORM
C HEADER LINE
         WRITE(JUNIT(2),55) KS, IMOV, KSTP, KPER, SUMTCH
  55  FORMAT('CONCENTRATIONS AT NODES IN SUBGRID LAYER ',I4,', IMOV='
     * ,I5,', KSTP=',I5,', KPER=',I5,', SUMTCH=',1PE10.4)
C
           DO 60 IS=1,NSROW
             WRITE(JUNIT(2),'(1P10E12.4)') (CONC(JS,IS,KS),JS=1,NSCOL)
  60       CONTINUE
C PRINT AS COL (X), ROW (Y), LAY (Z), CONC (SEPARATE LOOP BELOW)
         ELSEIF(ICONFM.LT.0) THEN
           COLPRT=1
         ENDIF
           ENDIF
       ENDIF
       IF(JUNIT(3).GT.0) THEN
         IF(KS.EQ.1.AND.IMOV.EQ.0) WRITE(IOUTS,65) JUNIT(3)
C PRINT BINARY FILE
  65  FORMAT('CONCENTRATION DATA WILL BE SAVED ON UNIT ',I3,
     *' IN BINARY FORMAT')
         CALL ULASAV(CONC(1,1,KKS),'CONCENTRATIONS  ',
cgzh     *     KSTP,KPER,PERTIM,TOTIM,NSCOL,NSROW,KK,JUNIT(3))
     *     KSTP,KPER,SUMTCH,TOTIM,NSCOL,NSROW,KK,JUNIT(3))
       ENDIF
  80  CONTINUE
      IF(COLPRT.GT.0) THEN
C PRINT IN X,Y,Z,C FORMAT
C HEADER LINE
         WRITE(JUNIT(2),56) IMOV, KSTP, KPER, SUMTCH
  56  FORMAT('CONCENTRATIONS AT NODES (X,Y,Z,CONC): IMOV='
     * ,I5,', KSTP=',I5,', KPER=',I5,', SUMTCH=',1PE10.4)
        TOTROW=0.0
        DO 61 I=1,NROW
        IS=I-ISROW1+1
        TOTROW=TOTROW+DELC(I)
         TOTCOL=0.0
         DO 61 J=1,NCOL
         JS=J-ISCOL1+1
         TOTCOL=TOTCOL+DELR(J)
          TOTTHK=0.0
          DO 61 K=1,NLAY
          KS=K-ISLAY1+1
            IF(K.GE.ISLAY1.AND.K.LE.ISLAY2.AND.
     *         I.GE.ISROW1.AND.I.LE.ISROW2.AND.
     *         J.GE.ISCOL1.AND.J.LE.ISCOL2) THEN
              TOTTHK=TOTTHK+THCK(JS,IS,KS)
              X=TOTCOL-(0.5*DELR(J))
              Y=TOTROW-(0.5*DELC(I))
              Z=TOTTHK-(0.5*THCK(JS,IS,KS))
              WRITE(JUNIT(2),'(1P4E12.4)') X,Y,Z,CONC(JS,IS,KS)
            END IF
  61    CONTINUE
      ENDIF
C PRINT MASS BALANCE
      IF(IMOV.GT.0)
     *   CALL SMOC6M(SBVL,SRCDCY,TIMV,IOUTS,KPER,NPER,KSTP,NSTP,
     *   IMOV,NMOV,SUMTCH,ICONLY,
     * JUNIT(11),IDKZO,IDKFO,IDKZS,IDKFS,
     * JUNIT(9),
     * JUNIT(10),IDPZO,IDPFO)
C
   50 RETURN
      END
C
C***************************************************************
C
      SUBROUTINE SMOC6V(THCK,BUFF,POR,RF,
     *                VC,VR,VL,IBOUND,DELT,KSTP,KPER,NSTP,NPER,
     *                NCOL,NROW,NLAY,NSCOL,NSROW,NSLAY,IOUTS,NTIMV,
     *                TIMV,VCMAX,VRMAX,VLMAX,TLMIN,IDIR,TOTIM,
     *                MAXVCJ,MAXVCI,MAXVCK,MAXVRJ,MAXVRI,MAXVRK,
     *                MAXVLJ,MAXVLI,MAXVLK,ITCD,
     *                NPNTVL,IVELFM,JUNIT,
cellam
     *                MOCTYPE,TCMIN,TRMIN,DELCOL,DELROW)
cellam
C
C-----from VERSION 1653 15MAY1987 SBAS1H
C     *******************************************************
C     PRINT VELOCITIES
C     *******************************************************
C
C        SPECIFICATIONS
C     -------------------------------------------------------
      COMMON /FLWCOM/LAYCON(200)
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
cellam
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
      DIMENSION DELCOL(NCOL),DELROW(NROW)
cellam
C
      DIMENSION THCK(NSCOL,NSROW,NSLAY),BUFF(NSCOL,NSROW,NSLAY),
     *   POR(NSCOL,NSROW,NSLAY),RF(NSCOL,NSROW,NSLAY),
     *   VC(NSCOL+1,NSROW,NSLAY),VR(NSCOL,NSROW+1,NSLAY),
     *   VL(NSCOL,NSROW,NSLAY+1),
     *   IBOUND(NCOL,NROW,NLAY),
     *   JUNIT(40)
C
C     -------------------------------------------------------
C  CHECK FLAGS FOR PRINTING VELOCITIES
      IPRNT=0
      IF(NPNTVL.EQ.0.AND.KPER.EQ.NPER.AND.KSTP.EQ.NSTP) IPRNT=1
      IF(NPNTVL.EQ.-1.AND.KSTP.EQ.NSTP) IPRNT=1
      IF(NPNTVL.GE.1) THEN
        IF(MOD(KSTP,NPNTVL).EQ.0.OR.
     *   (KPER.EQ.NPER.AND.KSTP.EQ.NSTP)) IPRNT=1
      ENDIF
C SKIP IF NO OUTPUT
      IF (IPRNT.EQ.0) GOTO 950
      IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
        DCINV=1.D0/CDEL
        DRINV=1.D0/RDEL
        ARINV=DCINV*DRINV
      ENDIF
C DON'T PRINT TO BOTH MAIN AND SEPARATE OUTPUT FILES
      IF(JUNIT(6).GT.0.AND.JUNIT(7).LE.0) GOTO 24
      IF(IDIR.EQ.1) THEN
         IF(JUNIT(6).LE.0) WRITE(IOUTS,320)
         IF(JUNIT(6).LE.0) WRITE(IOUTS,330)
         DO 50 KS=1,NSLAY
         K=KS+ISLAY1-1
CV  CONVERT BLOCK FACE VOLUMETRIC FLUXES TO RETARDED NODE VELOCITIES
cellam
         IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) DRIN2=DRINV/2.D0
cellam
         DO 52 IS=1,NSROW
            I=IS+ISROW1-1
            DO 51 JS=1,NSCOL
               J=JS+ISCOL1-1
               IF(IBOUND(J,I,K).EQ.0) THEN
                  BUFF(JS,IS,KS)=0.D0
               ELSE
cellam
                 IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
                   BUFF(JS,IS,KS)=(VC(JS,IS,KS)+VC(JS+1,IS,KS))*DRIN2/
     *                      (POR(JS,IS,KS)*THCK(JS,IS,KS)*RF(JS,IS,KS))
                 ELSEIF(MOCTYPE.EQ.3) THEN
                   RIN2=1/(2.D0*RF(JS,IS,KS))
                   BUFF(JS,IS,KS)=(VC(JS,IS,KS)+VC(JS+1,IS,KS))*RIN2/
     *            (RF(JS,IS,KS)*DELROW(I)*POR(JS,IS,KS)*THCK(JS,IS,KS))
                 END IF
cellam
               END IF
 51         CONTINUE
 52      CONTINUE
         KKS=KS
         KK=KS+ISLAY1-1
C OUTPUT TO TEXT FILE
         IF (JUNIT(6).LE.0) THEN
         IF(IVELFM.LT.0) CALL ULAPRS(BUFF(1,1,KKS),'VELOCITY (COL)  ',
     *     KSTP,KPER,NSCOL,NSROW,KK,-IVELFM,IOUTS)
         IF(IVELFM.GE.0) CALL ULAPRW(BUFF(1,1,KKS),'VELOCITY (COL)  ',
     *     KSTP,KPER,NSCOL,NSROW,KK,IVELFM,IOUTS)
         ENDIF
C OUTPUT TO BINARY FILE   
      IF (JUNIT(7).GT.0) CALL ULASAV(BUFF(1,1,KKS),'VELOCITY (COL)  ',
     *  KSTP,KPER,PERTIM,TOTIM,NSCOL,NSROW,KK,JUNIT(7))
   50    CONTINUE
C
      ELSEIF(IDIR.EQ.2) THEN
         IF(JUNIT(6).LE.0) WRITE(IOUTS,360)
         IF(JUNIT(6).LE.0) WRITE(IOUTS,330)
         DO 70 KS=1,NSLAY
C KK IS NUMBER OF FLOW LAYER
         K=KS+ISLAY1-1
         IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) DCIN2=DCINV/2.D0
         DO 72 IS=1,NSROW
            I=IS+ISROW1-1
            DO 71 JS=1,NSCOL
               J=JS+ISCOL1-1
               IF(IBOUND(J,I,K).EQ.0) THEN
                  BUFF(JS,IS,KS)=0.D0
               ELSE
cellam
                 IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
                  BUFF(JS,IS,KS)=(VR(JS,IS,KS)+VR(JS,IS+1,KS))*DCIN2/
     *                      (POR(JS,IS,KS)*THCK(JS,IS,KS)*RF(JS,IS,KS))
                 ELSEIF(MOCTYPE.EQ.3) THEN
                  RIN2=1/(2.D0*RF(JS,IS,KS))
                  BUFF(JS,IS,KS)=(VR(JS,IS,KS)+VR(JS,IS+1,KS))*RIN2/
     *            (DELCOL(J)*POR(JS,IS,KS)*THCK(JS,IS,KS)*RF(JS,IS,KS))
                 END IF
cellam
               END IF
 71         CONTINUE
 72      CONTINUE
         KKS=KS
         KK=KS+ISLAY1-1
         IF (JUNIT(6).LE.0) THEN
         IF(IVELFM.LT.0) CALL ULAPRS(BUFF(1,1,KKS),'VELOCITY (ROW)  ',
     *     KSTP,KPER,NSCOL,NSROW,KK,-IVELFM,IOUTS)
         IF(IVELFM.GE.0) CALL ULAPRW(BUFF(1,1,KKS),'VELOCITY (ROW)  ',
     *     KSTP,KPER,NSCOL,NSROW,KK,IVELFM,IOUTS)
         ENDIF
         IF (JUNIT(7).GT.0) CALL ULASAV(BUFF(1,1,KKS),
     *    'VELOCITY (ROW)  ',KSTP,KPER,PERTIM,TOTIM,NSCOL,NSROW,KK,
     *    JUNIT(7))
   70    CONTINUE
C
      ELSE
         IF(JUNIT(6).LE.0) WRITE(IOUTS,365)
         IF(JUNIT(6).LE.0) WRITE(IOUTS,330)
         DO 80 KS=1,NSLAY
         K=KS+ISLAY1-1
         IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) ARIN2=ARINV/2.D0
CV
         DO 82 IS=1,NSROW
            I=IS+ISROW1-1
            DO 81 JS=1,NSCOL
               J=JS+ISCOL1-1
               IF(IBOUND(J,I,K).EQ.0) THEN
                  BUFF(JS,IS,KS)=0.D0
               ELSE
cellam
                 IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
                  BUFF(JS,IS,KS)=(VL(JS,IS,KS)+VL(JS,IS,KS+1))*ARIN2/
     *                           (POR(JS,IS,KS)*RF(JS,IS,KS))
                 ELSEIF(MOCTYPE.EQ.3) THEN
                  RIN2=1/(2.D0*RF(JS,IS,KS))
                  BUFF(JS,IS,KS)=(VL(JS,IS,KS)+VL(JS,IS,KS+1))*RIN2/
     *               (DELCOL(J)*DELROW(I)*POR(JS,IS,KS)*RF(JS,IS,KS))
                 END IF
cellam
               END IF
 81         CONTINUE
 82      CONTINUE
         KKS=KS
         KK=KS+ISLAY1-1
         IF (JUNIT(6).LE.0) THEN
         IF(IVELFM.LT.0) CALL ULAPRS(BUFF(1,1,KKS),'VELOCITY (LAYER)',
     *     KSTP,KPER,NSCOL,NSROW,KK,-IVELFM,IOUTS)
         IF(IVELFM.GE.0) CALL ULAPRW(BUFF(1,1,KKS),'VELOCITY (LAYER)',
     *     KSTP,KPER,NSCOL,NSROW,KK,IVELFM,IOUTS)
         ENDIF
         IF (JUNIT(7).GT.0) CALL ULASAV(BUFF(1,1,KKS),
     *     'VELOCITY (LAYER)',
     *     KSTP,KPER,PERTIM,TOTIM,NSCOL,NSROW,KK,JUNIT(7))
 80      CONTINUE
      ENDIF
C
C TEXT (ASCII) OUTPUT FILE NEEDS RECONFIGURED DO LOOP STRUCTURE
C
 24   CONTINUE
      IF (JUNIT(6).GT.0.AND.IDIR.EQ.3) THEN
         WRITE(IOUTS,1133) JUNIT(6)
 1133 FORMAT (//'VELOCITY DATA BEING WRITTEN IN ASCII FORMAT ON',
     * ' UNIT', I3)
         DO 900 KS=1,NSLAY
C WRITE VC HEADER
          WRITE(JUNIT(6),85) KS, KSTP, KPER, TOTIM
  85  FORMAT('VEL. IN COLUMN DIRECTION (in 10E12.4), SUBGRID LAYER '
     * ,I4, 
     *', KSTP=',I5,', KPER=',I5,', TOTIM=',G15.6)
C
          K=KS+ISLAY1-1
          IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) DRIN2=DRINV/2.D0
CV
          DO 92 IS=1,NSROW
             I=IS+ISROW1-1
           DO 91 JS=1,NSCOL
              J=JS+ISCOL1-1
              IF(IBOUND(J,I,K).EQ.0) THEN
                 BUFF(JS,IS,KS)=0.D0
              ELSE
cellam
                 IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
                   BUFF(JS,IS,KS)=(VC(JS,IS,KS)+VC(JS+1,IS,KS))*DRIN2/
     *                      (POR(JS,IS,KS)*THCK(JS,IS,KS)*RF(JS,IS,KS))
                 ELSEIF(MOCTYPE.EQ.3) THEN
                   RIN2=1/(2.D0*RF(JS,IS,KS))
                   BUFF(JS,IS,KS)=(VC(JS,IS,KS)+VC(JS+1,IS,KS))*RIN2/
     *            (RF(JS,IS,KS)*DELROW(I)*POR(JS,IS,KS)*THCK(JS,IS,KS))
                 END IF
cellam
              END IF
 91        CONTINUE
           WRITE(JUNIT(6),'(1P10E12.4)') (BUFF(JS,IS,KS),JS=1,NSCOL)
 92       CONTINUE
C WRITE VR HEADER
          WRITE(JUNIT(6),95) KS, KSTP, KPER, TOTIM
  95  FORMAT('VEL. IN    ROW DIRECTION (in 10E12.4), SUBGRID LAYER '
     * ,I4,
     *', KSTP=',I5,', KPER=',I5,', TOTIM=',G15.6)
C
          IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) DCIN2=DCINV/2.D0
CV
          DO 102 IS=1,NSROW
             I=IS+ISROW1-1
           DO 101 JS=1,NSCOL
              J=JS+ISCOL1-1
              IF(IBOUND(J,I,K).EQ.0) THEN
                 BUFF(JS,IS,KS)=0.D0
              ELSE
cellam
                 IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
                  BUFF(JS,IS,KS)=(VR(JS,IS,KS)+VR(JS,IS+1,KS))*DCIN2/
     *                      (POR(JS,IS,KS)*THCK(JS,IS,KS)*RF(JS,IS,KS))
                 ELSEIF(MOCTYPE.EQ.3) THEN
                  CIN2=1/(2.D0*RF(JS,IS,KS))
                  BUFF(JS,IS,KS)=(VR(JS,IS,KS)+VR(JS,IS+1,KS))*CIN2/
     *            (DELCOL(J)*POR(JS,IS,KS)*THCK(JS,IS,KS)*RF(JS,IS,KS))
                 END IF
cellam
              END IF
 101       CONTINUE
            WRITE(JUNIT(6),'(1P10E12.4)') (BUFF(JS,IS,KS),JS=1,NSCOL)
 102      CONTINUE
C WRITE VL HEADER
          WRITE(JUNIT(6),105) KS, KSTP, KPER, TOTIM
 105  FORMAT('VEL. IN  LAYER DIRECTION (in 10E12.4), SUBGRID LAYER '
     * ,I4,
     *', KSTP=',I5,', KPER=',I5,', TOTIM=',G15.6)
C
          IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) ARIN2=ARINV/2.D0
CV
          DO 112 IS=1,NSROW
             I=IS+ISROW1-1
           DO 111 JS=1,NSCOL
              J=JS+ISCOL1-1
              IF(IBOUND(J,I,K).EQ.0) THEN
                 BUFF(JS,IS,KS)=0.D0
              ELSE
cellam
                 IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
                  BUFF(JS,IS,KS)=(VL(JS,IS,KS)+VL(JS,IS,KS+1))*ARIN2/
     *                           (POR(JS,IS,KS)*RF(JS,IS,KS))
                 ELSEIF(MOCTYPE.EQ.3) THEN
                  RIN2=1/(2.D0*RF(JS,IS,KS))
                  BUFF(JS,IS,KS)=(VL(JS,IS,KS)+VL(JS,IS,KS+1))*RIN2/
     *               (DELCOL(J)*DELROW(I)*POR(JS,IS,KS)*RF(JS,IS,KS))
                 END IF
cellam
              END IF
 111       CONTINUE
           WRITE(JUNIT(6),'(1P10E12.4)') (BUFF(JS,IS,KS),JS=1,NSCOL)
 112      CONTINUE
 900     CONTINUE
      ENDIF
C ENDIF FOR ASCII OUTPUT
C
C SKIP TO HERE IF NO OUTPUT
  950 CONTINUE
C     ---COMPUTE NEXT TIME STEP---
      IF (IDIR.EQ.3) THEN
cellam
  115  IF (CELDIS.NE.0.0) THEN
cellam
        IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
          TDELCB=CELDIS*CDEL/VCMAX
          TDELRB=CELDIS*RDEL/VRMAX
        ELSEIF (MOCTYPE.EQ.3) THEN
          TDELCB=CELDIS*TCMIN
          TDELRB=CELDIS*TRMIN
        ENDIF
        TDELLB=CELDIS*TLMIN
        ITCD=0
        IF(TDELRB.LT.TDELCB.AND.TDELRB.LE.TDELLB) ITCD=1
        IF(TDELLB.LT.TDELCB.AND.TDELLB.LT.TDELRB) ITCD=2
        TIMV=AMIN1(TDELCB,TDELRB,TDELLB)
cellam
        IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
          IF(AMAX1(VCMAX,VRMAX).LE.1.0E-20.AND.TLMIN.GE.1.0E+20)
     *      WRITE(IOUTS,570)
        ELSEIF(MOCTYPE.EQ.3) THEN
          IF(TCMIN.GE.1.0E+20.AND.TRMIN.GE.1.0E+20.AND.TLMIN.GE.1.0E+20)
     *      WRITE(IOUTS,570)
        ENDIF
cellam
        NTIMV=DELT/TIMV
        NTIMV=NTIMV+1
C
cellam
       ELSEIF(MOCTYPE.EQ.3) THEN
        TIMV=DELT
        NTIMV=1
       ENDIF
cellam
      ENDIF
C     ****************************************************************
C
  320 FORMAT(1H ///,
     * 'EFFECTIVE MEAN SOLUTE VELOCITIES IN COLUMN DIRECTION')
  330 FORMAT(1H ,25X,8HAT NODES/)
  360 FORMAT(1H ///,
     * 'EFFECTIVE MEAN SOLUTE VELOCITIES IN ROW DIRECTION')
  365 FORMAT(1H ///,
     * 'EFFECTIVE MEAN SOLUTE VELOCITIES IN LAYER DIRECTION')
  570 FORMAT(/5X,47H*** WARNING ***  DECREASE CRITERIA IN VELO SUBR)
      RETURN
      END
C
C
C***************************************************************
C
      SUBROUTINE SMOC5D(DISPCC,
     *  DISPCR,DISPCL,DISPRR,DISPRC,DISPRL,DISPLL,
     *  DISPLC,DISPLR,
     *  KSTP,NSTP,KPER,NPER,NSCOL,NSROW,NSLAY,
     *  IOUTS,NODISP,IDSPFM,NPNTDL)
C
C-----from VERSION 1653 15MAY1987 SBAS1H
C     *******************************************************
C     PRINT DISPERSION COEFFICIENTS
C     *******************************************************
C
C        SPECIFICATIONS
C     -------------------------------------------------------
C
      DIMENSION
     *  DISPCC(NSCOL,NSROW,NSLAY),DISPCR(NSCOL,NSROW,NSLAY),
     *  DISPCL(NSCOL,NSROW,NSLAY),DISPRR(NSCOL,NSROW,NSLAY),
     *  DISPRC(NSCOL,NSROW,NSLAY),DISPRL(NSCOL,NSROW,NSLAY),
     *  DISPLL(NSCOL,NSROW,NSLAY),DISPLC(NSCOL,NSROW,NSLAY),
     *  DISPLR(NSCOL,NSROW,NSLAY)
C
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C     ---PRINT DISPERSION EQUATION COEFFICIENTS---
C     -------------------------------------------------------
C  DETERMINE IF AND WHEN DISPERSION COEFFICIENTS SHOULD BE PRINTED
      IF(NPNTDL.EQ.0) RETURN
      IPRNT=0
      IF(NPNTDL.GT.0) THEN
         IF(MOD(KSTP,NPNTDL).EQ.0) IPRNT=1
      END IF
      IF(NPNTDL.EQ.-1.AND.KSTP.EQ.NSTP.AND.KPER.EQ.NPER) IPRNT=1
      IF(NPNTDL.EQ.-2.AND.KSTP.EQ.NSTP) IPRNT=1
      IF(IPRNT.EQ.0) RETURN
C
      WRITE(IOUTS,450)
      WRITE(IOUTS,460)
      DO 80 KS=1,NSLAY
      KKS=KS
      KK=KS+ISLAY1-1
      WRITE(IOUTS,7763) KK
 7763 FORMAT(/' FOR FLOW LAYER K=',I3/)
      IF(IDSPFM.LT.0)
     *CALL ULAPRS(DISPCC(1,1,KKS),'DISPCC IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,-IDSPFM,IOUTS)
      IF(IDSPFM.GE.0)
     *CALL ULAPRW(DISPCC(1,1,KKS),'DISPCC IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,IDSPFM,IOUTS)
   80 CONTINUE
      WRITE(IOUTS,470)
      DO 90 KS=1,NSLAY
      KKS=KS
      KK=KS+ISLAY1-1
      WRITE(IOUTS,7763) KK
      IF(IDSPFM.LT.0)
     *CALL ULAPRS(DISPRR(1,1,KKS),'DISPRR IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,-IDSPFM,IOUTS)
      IF(IDSPFM.GE.0)
     *CALL ULAPRW(DISPRR(1,1,KKS),'DISPRR IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,IDSPFM,IOUTS)
   90 CONTINUE
      WRITE(IOUTS,491)
      DO 100 KS=1,NSLAY
      KKS=KS
      KK=KS+ISLAY1-1
      KKP1=KK+1
      WRITE(IOUTS,7764) KK,KKP1
 7764 FORMAT(/' BETWEEN FLOW LAYERS K=',I3,'   AND K+1=',I3/)
      IF(IDSPFM.LT.0)
     *CALL ULAPRS(DISPLL(1,1,KKS),'DISPLL IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,-IDSPFM,IOUTS)
      IF(IDSPFM.GE.0)
     *CALL ULAPRW(DISPLL(1,1,KKS),'DISPLL IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,IDSPFM,IOUTS)
  100 CONTINUE
C  SKIP REST OF PRINTING IF NO DISPERSION
      IF(NODISP.EQ.1) GO TO 170
      WRITE(IOUTS,480)
      DO 110 KS=1,NSLAY
      KK=KS
      KK=KS+ISLAY1-1
      WRITE(IOUTS,7763) KK
      IF(IDSPFM.LT.0)
     *CALL ULAPRS(DISPCR(1,1,KKS),'DISPCR IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,-IDSPFM,IOUTS)
      IF(IDSPFM.GE.0)
     *CALL ULAPRW(DISPCR(1,1,KKS),'DISPCR IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,IDSPFM,IOUTS)
  110 CONTINUE
      WRITE(IOUTS,490)
      DO 120 KS=1,NSLAY
      KKS=KS
      KK=KS+ISLAY1-1
      WRITE(IOUTS,7763) KK
      IF(IDSPFM.LT.0)
     *CALL ULAPRS(DISPRC(1,1,KKS),'DISPRC IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,-IDSPFM,IOUTS)
      IF(IDSPFM.GE.0)
     *CALL ULAPRW(DISPRC(1,1,KKS),'DISPRC IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,IDSPFM,IOUTS)
  120 CONTINUE
      WRITE(IOUTS,492)
      DO 130 KS=1,NSLAY
      KKS=KS
      KK=KS+ISLAY1-1
      WRITE(IOUTS,7763) KK
      IF(IDSPFM.LT.0)
     *CALL ULAPRS(DISPCL(1,1,KKS),'DISPCL IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,-IDSPFM,IOUTS)
      IF(IDSPFM.GE.0)
     *CALL ULAPRW(DISPCL(1,1,KKS),'DISPCL IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,IDSPFM,IOUTS)
  130 CONTINUE
      WRITE(IOUTS,493)
      DO 140 KS=1,NSLAY
      KKS=KS
      KK=KS+ISLAY1-1
      WRITE(IOUTS,7763) KK
      IF(IDSPFM.LT.0)
     *CALL ULAPRS(DISPRL(1,1,KKS),'DISPRL IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,-IDSPFM,IOUTS)
      IF(IDSPFM.GE.0)
     *CALL ULAPRW(DISPRL(1,1,KKS),'DISPRL IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,IDSPFM,IOUTS)
  140 CONTINUE
      WRITE(IOUTS,494)
      DO 150 KS=1,NSLAY
      KKS=KS
      KK=KS+ISLAY1-1
      KKP1=KK+1
      WRITE(IOUTS,7764) KK,KKP1
      IF(IDSPFM.LT.0)
     *CALL ULAPRS(DISPLC(1,1,KKS),'DISPLC IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,-IDSPFM,IOUTS)
      IF(IDSPFM.GE.0)
     *CALL ULAPRW(DISPLC(1,1,KKS),'DISPLC IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,IDSPFM,IOUTS)
  150 CONTINUE
      WRITE(IOUTS,495)
      DO 160 KS=1,NSLAY
      KKS=KS
      KK=KS+ISLAY1-1
      KKP1=KK+1
      WRITE(IOUTS,7764) KK,KKP1
      IF(IDSPFM.LT.0)
     *CALL ULAPRS(DISPLR(1,1,KKS),'DISPLR IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,-IDSPFM,IOUTS)
      IF(IDSPFM.GE.0)
     *CALL ULAPRW(DISPLR(1,1,KKS),'DISPLR IN DSP1FM',
     *            KSTP,KPER,NSCOL,NSROW,KK,IDSPFM,IOUTS)
  160 CONTINUE
C     ****************************************************************
  170 CONTINUE
      RETURN
C     ****************************************************************
C
C
C
  330 FORMAT(1H ,25X,8HAT NODES/)
C      ACTIVATE NEXT LINE IF BOUNDARY VELOCITIES PRINTED
  350 FORMAT(1H ,1P10E12.3)
  450 FORMAT(1H ///,32HDISPERSION EQUATION COEFFICIENTS,10X,33H=(D-IJ)*(
     1B)*(POROS)/(GRID FACTOR))
  460 FORMAT(/35X,14HCC COEFFICIENT/)
  470 FORMAT(/35X,14HRR COEFFICIENT/)
  480 FORMAT(/35X,14HCR COEFFICIENT/)
  490 FORMAT(/35X,14HRC COEFFICIENT/)
  491 FORMAT(/35X,14HLL COEFFICIENT/)
  492 FORMAT(/35X,14HCL COEFFICIENT/)
  493 FORMAT(/35X,14HRL COEFFICIENT/)
  494 FORMAT(/35X,14HLC COEFFICIENT/)
  495 FORMAT(/35X,14HLR COEFFICIENT/)
      END
C
C*************************************************************************
C SMOC5P   DUMP PARTICLE LOCATIONS FOR PLOTTING
C     *************************************************************
      SUBROUTINE SMOC5P(PC,PR,PL,PCONC,
     *                  IOUTPD,KPER,NPER,KSTP,NSTP,IMOV,NMOV,TIMV,NP,
     *                  SUMTCH,NPNTPL,IFLAG)
C     ***************************************************************
      DIMENSION PC(NP),PR(NP),PL(NP),PCONC(NP)
C     ***************************************************************
C CHECK FLAGS FOR OUTPUT    
      IPRNT=0
      IF (NPNTPL.EQ.0.AND.KPER.EQ.NPER.AND.KSTP.EQ.NSTP.
     *AND.IMOV.EQ.NMOV) IPRNT=1
      IF (NPNTPL.EQ.-2.AND.KSTP.EQ.NSTP.AND.IMOV.EQ.NMOV) IPRNT=1
      IF (NPNTPL.EQ.-1.AND.IMOV.EQ.NMOV) IPRNT=1
      IF(NPNTPL.GE.1) THEN
        IF(MOD(IMOV,NPNTPL).EQ.0.OR.
     *   (KPER.EQ.NPER.AND.KSTP.EQ.NSTP.AND.IMOV.EQ.NMOV)) IPRNT=1
      ENDIF
C INITIAL CONDITION        
      IF(IMOV.EQ.0) IPRNT=1
C SKIP IF NO OUTPUT
      IF (IPRNT.EQ.0) RETURN
C
      IF(IFLAG.EQ.0) THEN
       WRITE(IOUTPD,11) KPER,KSTP,IMOV,NP,TIMV,SUMTCH 
       WRITE(IOUTPD,12) (PC(IP),ABS(PR(IP)),PL(IP),PCONC(IP),IP=1,NP)
      ELSE
C PRINT UNFORMATTED BINARY OUTPUT
         WRITE(IOUTPD) IMOV,NP,TIMV,SUMTCH
         WRITE(IOUTPD) (PC(IP),ABS(PR(IP)),PL(IP),PCONC(IP),IP=1,NP)
      END IF
  11  FORMAT(4I10,1PE12.4,1PE12.4)
  12  FORMAT(4E12.4)
      RETURN
      END
C
C*************************************************************************
C SMOC5TK   SET INITIAL SATURATED THICKNESS      
C
C*************************************************************************
C
      SUBROUTINE SMOC5TK(HNEW,
     *  IBOUND,HOLD,TOP,
     *  THCK,BOT,
     *  NSCOL,NSROW,NSLAY,
     *  NCOL,NROW,NLAY,IOUTS,ISS)
C
C*************************************************************************
C
      DOUBLE PRECISION HNEW
C
      DIMENSION HNEW(NCOL,NROW,NLAY),
     *  IBOUND(NCOL,NROW,NLAY),
     *  HOLD(NCOL,NROW,NLAY),
     *  TOP(NCOL,NROW,NLAY),
     *  THCK(NSCOL,NSROW,NSLAY),
     *  BOT(NCOL,NROW,NLAY)
C
      COMMON /FLWCOM/LAYCON(200)
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C*************************************************************************
C    SET INITIAL SATURATED THICKNESS
C     FOR WATER-TABLE CELLS USE FLOW MODEL INFORMATION
C     SET THICKNESS TO ZERO IN INACTIVE CELLS
C
C  LOOP FOR ALL LAYERS TO SET TOP COUNTER
      KB=0
      KT=0
      DO 40 K=1,NLAY
      IF(LAYCON(K).EQ.1.OR.LAYCON(K).EQ.3) KB=KB+1
      IF(LAYCON(K).EQ.3) KT=KT+1
      KS=K-ISLAY1+1
C  SKIP IF LAYER NOT IN TRANSPORT SUBGRID
      IF(KS.LE.0.OR.KS.GT.NSLAY) GO TO 40
C
      DO 10 IS=1,NSROW
      I=IS+ISROW1-1
      DO 10 JS=1,NSCOL
      J=JS+ISCOL1-1
C  SET THICKNESS TO ZERO IN INACTIVE CELLS
      IF(IBOUND(J,I,K).EQ.0) THEN
c beta ellam had:   THCK(JS,IS,KS)=1D30 
         THCK(JS,IS,KS)=0.D0
         GO TO 10
      END IF
C  SKIP IF CONSTANT THICKNESS
      IF(LAYCON(K).NE.1.AND.LAYCON(K).NE.3) GO TO 10
C  FOR SS FLOW, USE HEAD SOLUTION
      IF(ISS.EQ.1) THEN
         HD=HNEW(J,I,K)
      ELSE
C  FOR TRANSIENT FLOW, USE OLD (INITIAL) HEAD
         HD=HOLD(J,I,K)
      END IF
C  CALCULATE SATURATED THICKNESS
      IF(LAYCON(K).EQ.1) THEN
         THCK(JS,IS,KS)=HD-BOT(J,I,KB)
      ELSE
         THCK(JS,IS,KS)=MIN(HD,TOP(J,I,KT))-BOT(J,I,KB)
      END IF
   10 CONTINUE
   40 CONTINUE
C
      RETURN
      END
C
C
C*************************************************************************
C
      SUBROUTINE SMOC5UP(HNEW,
     *           IBOUND,HOLD,TOP,
     *  SC1,SC2,THCK,POR,BUFF,DELT,
     *  NSCOL,NSROW,NSLAY,
     *  NCOL,NROW,NLAY,IOUTS,
cellam
     *  MOCTYPE,DELCOL,DELROW)
cellam
C
C*************************************************************************
C STORAGE TERM UPDATING
C*************************************************************************
C
      DOUBLE PRECISION HNEW
C
      DIMENSION HNEW(NCOL,NROW,NLAY),
     *  IBOUND(NCOL,NROW,NLAY),
     *  HOLD(NCOL,NROW,NLAY),
     *  TOP(NCOL,NROW,NLAY),SC1(NCOL,NROW,NLAY),
     *  SC2(NCOL,NROW,NLAY),
     *  THCK(NSCOL,NSROW,NSLAY),
     *  POR(NSCOL,NSROW,NSLAY)
C
      DIMENSION BUFF(NCOL,NROW,NLAY)
C
cellam
      DIMENSION DELCOL(NCOL),DELROW(NROW)
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
cellam
      COMMON /FLWCOM/LAYCON(200)
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C*************************************************************************
C
      ARINV=1.D0/(CDEL*RDEL)
      DTOVAR=DELT*ARINV
C
C  UPDATE FLUID STORAGE TERMS
C
C  LOOP FOR ALL LAYERS TO SET TOP COUNTER
      KT=0
      DO 40 K=1,NLAY
      IF(LAYCON(K).EQ.2.OR.LAYCON(K).EQ.3) KT=KT+1
      KS=K-ISLAY1+1
      IF(KS.LE.0.OR.KS.GT.NSLAY) GO TO 40
C
      IF(LAYCON(K).EQ.1) THEN
C
C  FOR UNCONFINED LAYERS, PRIMARY STORAGE COEFFICIENT IS ASSUMED
C   TO BE SPECIFIC YIELD
C   UPDATE APPLIED TO SATURATED THICKNESS, POROSITY CONSTANT
C
         DO 10 IS=1,NSROW
         I=IS+ISROW1-1
         DO 10 JS=1,NSCOL
         J=JS+ISCOL1-1
C  SKIP IF INACTIVE AT ENDING TIME, THIS MAY TRAP PARTICLES
         IF(IBOUND(J,I,K).LE.0) GO TO 10
cellam
         IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
cgzh pending bug fix
cgzh           THCK(JS,IS,KS)=THCK(JS,IS,KS)+
cgzh     *         BUFF(J,I,K)*DTOVAR/POR(JS,IS,KS)
           THCK(JS,IS,KS)=THCK(JS,IS,KS)-
     *         BUFF(J,I,K)*DTOVAR/POR(JS,IS,KS)
         ELSEIF (MOCTYPE.EQ.3) THEN
cgzh           THCK(JS,IS,KS)=THCK(JS,IS,KS)+
cgzh     *       (BUFF(J,I,K)*DELT)/(DELCOL(J)*DELROW(I)*POR(JS,IS,KS))
           THCK(JS,IS,KS)=THCK(JS,IS,KS)-
     *       (BUFF(J,I,K)*DELT)/(DELCOL(J)*DELROW(I)*POR(JS,IS,KS))
         ENDIF
cellam
C  MOC3D NOT COMPATIBLE WITH REWETTING OPTION;  STOP IF CELLS DEWATER
         IF(THCK(JS,IS,KS).LE.0.0) THEN
            WRITE(IOUTS,*) ' ERROR, ACTIVE CELL DEWATERED FOR TRANSPORT'
            WRITE(IOUTS,*) 'js,is,ks',js,is,ks
            WRITE(IOUTS,*) 'buff,delt,delc,delr,thck,por,ibound',
     *    BUFF(J,I,K),
     *    DELT,DELCOL(J),DELROW(I),THCK(JS,IS,KS),por(js,is,ks),
     *      ibound(j,i,k)
            STOP ' UPDATE-DEWATERING 1'
         END IF
   10    CONTINUE
      ELSE IF(LAYCON(K).EQ.0) THEN
C
C  FOR CONFINED LAYERS, PRIMARY STORAGE COEFFICIENT IS ASSUMED TO
C    BE SPECIFIC STORATIVITY
C   UPATE APPLIED TO POROSITY, THICKNESS CONSTANT
C
         DO 20 IS=1,NSROW
         I=IS+ISROW1-1
         DO 20 JS=1,NSCOL
         J=JS+ISCOL1-1
         IF(IBOUND(J,I,K).LE.0) GO TO 20
cellam
         IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
           POR(JS,IS,KS)=POR(JS,IS,KS)+
     *           BUFF(J,I,K)*DTOVAR/THCK(JS,IS,KS)
         ELSEIF (MOCTYPE.EQ.3) THEN
           POR(JS,IS,KS)=POR(JS,IS,KS)+
     *         (BUFF(J,I,K)*DELT)/(DELCOL(J)*DELROW(I)*THCK(JS,IS,KS))
         ENDIF
cellam
C  MOC3D NOT COMPATIBLE WITH REWETTING OPTION;  STOP IF CELLS DEWATER
         IF(POR(JS,IS,KS).LE.0.0) THEN
            WRITE(IOUTS,*) ' ERROR, ACTIVE CELL DEWATERED FOR TRANSPORT'
            WRITE(IOUTS,*) 'js,is,ks',js,is,ks
            WRITE(IOUTS,*) 'buff,delt,delc,delr,thck,por,ibound'
     *    ,BUFF(J,I,K),
     *    DELT,DELCOL(J),DELROW(I),THCK(JS,IS,KS),por(js,is,ks),
     *      ibound(j,i,k)
            STOP ' UPDATE-DEWATERING 2'
         END IF
   20    CONTINUE
      ELSE
C
C  FOR CONVERTIBLE LAYERS, PRIMARY IS SPECIFIC STORATIVITY,
C   SECONDARY IS SPECIFIC YIELD, BOTH POROSITY AND THICKNESS MAY CHANGE
C
         DO 30 IS=1,NSROW
         I=IS+ISROW1-1
         DO 30 JS=1,NSCOL
         J=JS+ISCOL1-1
         IF(IBOUND(J,I,K).LE.0) GO TO 30
         TOPL=TOP(J,I,KT)
         HTNEW=HNEW(J,I,K)-TOPL
         HTOLD=HOLD(J,I,K)-TOPL
C
C  CHANGE POROSITY FOR HEAD CHANGE ABOVE TOP
C  CHANGE THICKNESS FOR HEAD CHANGE BELOW TOP
C
cellam
       IF(MOCTYPE.EQ.1.OR.MOCTYPE.EQ.2) THEN
C  BOTH OLD AND NEW HEAD ABOVE TOP, CHANGE POROSITY ONLY
         IF(HTNEW.GT.0.0.AND.HTOLD.GE.0.0) THEN
          POR(JS,IS,KS)=POR(JS,IS,KS)+BUFF(J,I,K)*DTOVAR/THCK(JS,IS,KS)
C
C  OLD HEAD BELOW TOP, NEW HEAD ABOVE TOP
         ELSE IF(HTNEW.GT.0.0.AND.HTOLD.LT.0.0) THEN
C  FIRST, INCREASE THICKNESS
            THCK(JS,IS,KS)=THCK(JS,IS,KS)-SC2(J,I,K)*HTOLD*ARINV
     *                       /POR(JS,IS,KS)
C  THEN INCREASE POROSITY
            POR(JS,IS,KS)=POR(JS,IS,KS)+SC1(J,I,K)*HTNEW*ARINV
     *                      /THCK(JS,IS,KS)
C
C  BOTH OLD AND NEW HEAD BELOW TOP, CHANGE THICKNESS ONLY
         ELSE IF(HTNEW.LE.0.0.AND.HTOLD.LT.0.0) THEN
          THCK(JS,IS,KS)=THCK(JS,IS,KS)+BUFF(J,I,K)*DTOVAR/POR(JS,IS,KS)
C  OLD HEAD ABOVE TOP, NEW HEAD BELOW TOP
         ELSE IF(HTNEW.LT.0.0.AND.HTOLD.GT.0.0) THEN
C  FIRST DECREASE POROSITY
            POR(JS,IS,KS)=POR(JS,IS,KS)-SC1(J,I,K)*HTOLD*ARINV
     *                                    /THCK(JS,IS,KS)
C  THEN DECREASE THICKNESS
            THCK(JS,IS,KS)=THCK(JS,IS,KS)+SC2(J,I,K)*HTNEW*ARINV
     *                                      /POR(JS,IS,KS)
         END IF
       ELSEIF(MOCTYPE.EQ.3) THEN
         IF(HTNEW.GT.0.0.AND.HTOLD.GE.0.0) THEN
          POR(JS,IS,KS)=POR(JS,IS,KS)+(BUFF(J,I,K)*DELT)/
     *                  (DELCOL(J)*DELROW(I)*THCK(JS,IS,KS))
         ELSE IF(HTNEW.GT.0.0.AND.HTOLD.LT.0.0) THEN
            THCK(JS,IS,KS)=THCK(JS,IS,KS)-(SC2(J,I,K)*HTOLD)
     *                       /(DELCOL(J)*DELROW(I)*POR(JS,IS,KS))
            POR(JS,IS,KS)=POR(JS,IS,KS)+(SC1(J,I,K)*HTNEW)
     *                      /(DELCOL(J)*DELROW(I)*THCK(JS,IS,KS))
         ELSE IF(HTNEW.LE.0.0.AND.HTOLD.LT.0.0) THEN
          THCK(JS,IS,KS)=THCK(JS,IS,KS)+(BUFF(J,I,K)*DELT)/
     *                   (DELCOL(J)*DELROW(I)*POR(JS,IS,KS))
         ELSE IF(HTNEW.LT.0.0.AND.HTOLD.GT.0.0) THEN
            POR(JS,IS,KS)=POR(JS,IS,KS)-(SC1(J,I,K)*HTOLD)
     *                    /(DELCOL(J)*DELROW(I)*THCK(JS,IS,KS))
            THCK(JS,IS,KS)=THCK(JS,IS,KS)+(SC2(J,I,K)*HTNEW)
     *                     /(DELCOL(J)*DELROW(I)*POR(JS,IS,KS))
         ENDIF
       ENDIF
cellam
C  MOC3D NOT COMPATIBLE WITH REWETTING OPTION;  STOP IF CELLS DEWATER
         IF(POR(JS,IS,KS).LE.0.0.OR.THCK(JS,IS,KS).LE.0.0) THEN
            WRITE(IOUTS,*) ' ERROR, ACTIVE CELL DEWATERED FOR TRANSPORT'
            WRITE(IOUTS,*) 'js,is,ks',js,is,ks
            WRITE(IOUTS,*) 'buff,delt,delc,delr,thck,por,ibound'
     *    ,BUFF(J,I,K),
     *    DELT,DELCOL(J),DELROW(I),THCK(JS,IS,KS),por(js,is,ks),
     *      ibound(j,i,k)
            STOP ' UPDATE-DEWATERING 3'
         END IF
   30    CONTINUE
      END IF
   40 CONTINUE
C
      RETURN
      END
C
C
C*************************************************************************
C
      SUBROUTINE SMOC6UP(HNEW,
c     *           IBOUND,HOLD,TOP,
     *           HOLD,TOP,
     *  SC1,SC2,THCK,POR,BUFF,DELT,
     *  NSCOL,NSROW,NSLAY,
     *  NCOL,NROW,NLAY,IOUTS,
cellam
     *  MOCTYPE,DELCOL,DELROW,TEMP,RHS,CONC,
cch
     *  ibound,ibounc,
     *  HDRY,CR,CC,CV,KPER,KSTP,KITER,IOUT)
cellam
C
C*************************************************************************
C STORAGE TERM UPDATING
C*************************************************************************
C
      DOUBLE PRECISION HNEW
C
      DIMENSION HNEW(NCOL,NROW,NLAY),
     *  IBOUND(NCOL,NROW,NLAY),
cch
     *  IBOUNC(NCOL,NROW,NLAY),
cch
     *  HOLD(NCOL,NROW,NLAY),
     *  TOP(NCOL,NROW,NLAY),SC1(NCOL,NROW,NLAY),
     *  SC2(NCOL,NROW,NLAY),
     *  THCK(NSCOL,NSROW,NSLAY),
     *  POR(NSCOL,NSROW,NSLAY)
C
      DIMENSION BUFF(NCOL,NROW,NLAY)
      DIMENSION RHS(NSCOL,NSROW,NSLAY),TEMP(NSCOL,NSROW,NSLAY),
     *  CONC(NSCOL,NSROW,NSLAY),
cch
     *  CR(NCOL,NROW,NLAY),CC(NCOL,NROW,NLAY),CV(NCOL,NROW,NLAY)

C
      CHARACTER*3 ACNVRT
      DIMENSION ICNVRT(5),JCNVRT(5),ACNVRT(5)
cch

cellam
      DIMENSION DELCOL(NCOL),DELROW(NROW)
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
cellam
      COMMON /FLWCOM/LAYCON(200)
      COMMON /MOC3D/ CDEL,RDEL,CNOFLO,CELDIS,FZERO,NZCRIT
      COMMON /SUBGRD/
     *  ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,ISLAY2,ISUBGD
C
C*************************************************************************
C
cch
      ZERO=0.0
C
C  UPDATE FLUID STORAGE TERMS
C
C  LOOP FOR ALL LAYERS TO SET TOP COUNTER
      KT=0
      DO 40 K=1,NLAY
      IF(LAYCON(K).EQ.2.OR.LAYCON(K).EQ.3) KT=KT+1
      KS=K-ISLAY1+1
      IF(KS.LE.0.OR.KS.GT.NSLAY) GO TO 40
C
      IF(LAYCON(K).EQ.1) THEN
C
C  FOR UNCONFINED LAYERS, PRIMARY STORAGE COEFFICIENT IS ASSUMED
C   TO BE SPECIFIC YIELD
C   UPDATE APPLIED TO SATURATED THICKNESS, POROSITY CONSTANT
C
         DO 10 IS=1,NSROW
         I=IS+ISROW1-1
         DO 10 JS=1,NSCOL
         J=JS+ISCOL1-1
C  SKIP IF INACTIVE AT ENDING TIME, THIS MAY TRAP PARTICLES
cellam
          IF(IBOUNC(J,I,K).EQ.0) GO TO 10
           THCK(JS,IS,KS)=THCK(JS,IS,KS)-
     *       (BUFF(J,I,K)*DELT)/(DELCOL(J)*DELROW(I)*POR(JS,IS,KS))
cellam

C  MOC3D NOT COMPATIBLE WITH REWETTING OPTION;  STOP IF CELLS DEWATER
         IF(THCK(JS,IS,KS).LE.ZERO.AND.IBOUNC(J,I,K).NE.0) THEN
cch
           THCK(JS,IS,KS)=TEMP(JS,IS,KS)
           IBOUNC(J,I,K)=0
C
         END IF
   10    CONTINUE
      ELSE IF(LAYCON(K).EQ.0) THEN
C
C  FOR CONFINED LAYERS, PRIMARY STORAGE COEFFICIENT IS ASSUMED TO
C    BE SPECIFIC STORATIVITY
C   UPATE APPLIED TO POROSITY, THICKNESS CONSTANT
C
         DO 20 IS=1,NSROW
         I=IS+ISROW1-1
         DO 20 JS=1,NSCOL
         J=JS+ISCOL1-1
cellam
         IF(IBOUNC(J,I,K).LE.0) GO TO 20
           POR(JS,IS,KS)=POR(JS,IS,KS)+
     *         (BUFF(J,I,K)*DELT)/(DELCOL(J)*DELROW(I)*THCK(JS,IS,KS))
cellam
C  MOC3D NOT COMPATIBLE WITH REWETTING OPTION;  STOP IF CELLS DEWATER
         IF(POR(JS,IS,KS).LE.0.0) THEN
            WRITE(IOUTS,*) ' ERROR, ACTIVE CELL DEWATERED FOR TRANSPORT'
cgzh
            WRITE(IOUTS,*) 'js,is,ks,por',js,is,ks,por(js,is,ks)
            WRITE(IOUTS,*) 'buff,delt,delc,delr,thck',BUFF(J,I,K),
     *    DELT,DELCOL(J),DELROW(I),THCK(JS,IS,KS)
            STOP ' UPDATE-DEWATERING 2'
         END IF
   20    CONTINUE
      ELSE
C
C  FOR CONVERTIBLE LAYERS, PRIMARY IS SPECIFIC STORATIVITY,
C   SECONDARY IS SPECIFIC YIELD, BOTH POROSITY AND THICKNESS MAY CHANGE
C
         DO 30 IS=1,NSROW
         I=IS+ISROW1-1
         DO 30 JS=1,NSCOL
         J=JS+ISCOL1-1
         IF(IBOUNC(J,I,K).LE.0) GO TO 30
         TOPL=TOP(J,I,KT)
         HTNEW=HNEW(J,I,K)-TOPL
         HTOLD=HOLD(J,I,K)-TOPL
C
C  CHANGE POROSITY FOR HEAD CHANGE ABOVE TOP
C  CHANGE THICKNESS FOR HEAD CHANGE BELOW TOP
C
         IF(HTNEW.GT.0.0.AND.HTOLD.GE.0.0) THEN
          POR(JS,IS,KS)=POR(JS,IS,KS)+(BUFF(J,I,K)*DELT)/
     *                  (DELCOL(J)*DELROW(I)*THCK(JS,IS,KS))
         ELSE IF(HTNEW.GT.0.0.AND.HTOLD.LT.0.0) THEN
            THCK(JS,IS,KS)=THCK(JS,IS,KS)+(SC2(J,I,K)*HTOLD)
     *                       /(DELCOL(J)*DELROW(I)*POR(JS,IS,KS))
            POR(JS,IS,KS)=POR(JS,IS,KS)+(SC1(J,I,K)*HTNEW)
     *                      /(DELCOL(J)*DELROW(I)*THCK(JS,IS,KS))
         ELSE IF(HTNEW.LE.0.0.AND.HTOLD.LT.0.0) THEN
          THCK(JS,IS,KS)=THCK(JS,IS,KS)-(BUFF(J,I,K)*DELT)/
     *                   (DELCOL(J)*DELROW(I)*POR(JS,IS,KS))
         ELSE IF(HTNEW.LT.0.0.AND.HTOLD.GT.0.0) THEN
            POR(JS,IS,KS)=POR(JS,IS,KS)-(SC1(J,I,K)*HTOLD)
     *                    /(DELCOL(J)*DELROW(I)*THCK(JS,IS,KS))
            THCK(JS,IS,KS)=THCK(JS,IS,KS)-(SC2(J,I,K)*HTNEW)
     *                     /(DELCOL(J)*DELROW(I)*POR(JS,IS,KS))
         ENDIF
cellam
C  MOC3D NOT COMPATIBLE WITH REWETTING OPTION;  STOP IF CELLS DEWATER
         IF(POR(JS,IS,KS).LE.0.0.OR.THCK(JS,IS,KS).LE.0.0) THEN
            WRITE(IOUTS,*) ' ERROR, ACTIVE CELL DEWATERED FOR TRANSPORT'
            STOP ' UPDATE-DEWATERING 3'
         END IF
   30    CONTINUE
      END IF
   40 CONTINUE
C
      DO KS=1,NSLAY
        K=ISLAY1+KS-1
        DO IS=1,NSROW
          I=ISROW1+IS-1
          DO JS=1,NSCOL
            J=ISCOL1+JS-1
            IF (IBOUNC(J,I,K).NE.0) THEN
C
              RHS(JS,IS,KS)=TEMP(JS,IS,KS)/POR(JS,IS,KS)
C
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C
      RETURN
      END
C
C*************************************************************************
C
C
C
C  SMOC6I   COPY IBOUND ARRAY
C*************************************************************************
C
      SUBROUTINE SMOC6I(IBOUND,IBOUNC,NODES)
C
C*************************************************************************
C
      DIMENSION IBOUND(NODES),IBOUNC(NODES) 
C
      DO 10 N=1,NODES
          IBOUNC(N)=IBOUND(N)
10    CONTINUE
C
      RETURN
      END
C
