C
      SUBROUTINE ELLOUT(CBNDY,DIAGO,RHSO,NONU,SAV,IDBNDY,RHS,RF,ibound,
     *          NSCOL,NSROW,NSLAY,NTFACE,NODESS,JRF,NFACES,POR,cnold,
     *          NCOL,NROW,NLAY,NRFLG)

C*************************************************************************
C  ELLOUT SOLVE FOR NEW CONCENTRATION ON OUTFLOW BOUNDARY
C         MOVE INFLOW/OUTFLOW BNDY MASS FROM NEW TIME INTEGRATION TO RHS
C         ACCUMULATE MASS REPRESENTED BY IN/OUT BNDY NODE FOR MASS BALANCE
C
C  ELLOUT READS IDBNDY TO DETERMINE OUTFLOW FACES, AND FOR EACH OUTFLOW
C  FACE SOLVES FOR CONCENTRATION=RHSO/DIAGO.
C***********************************************************************
C
      PARAMETER (PRECNO=5.D-7)
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
      DIMENSION CBNDY(NTFACE),DIAGO(NTFACE),RHSO(NTFACE),
     *       RF(NSCOL,NSROW,NSLAY),IBOUND(NCOL,NROW,NLAY),
     *       NONU(2,32*NFACES),SAV(32*NFACES),RHS(NODESS),POR(NODESS),
     *       IDBNDY(NFACES),cnold(nodess)
C
C  DIAGO HOLDS DIAGONAL ENTRIES OF DIAGONAL MATRIX ON LHS OF OUTFLOW
C  EQUATION; RHSO HOLDS RHS OF OUTFLOW.
C
C  CBNDY CONTAINS CONCENTRATION AT EACH BOUNDARY FACE.
C
C  IDBNDY HAS ENTRY CORRESPONDING TO EACH CTCFLO ENTRY.
C  FOR EACH CTCFLO ENTRY,
C      IDBNDY(CTCFLO ID)= -FACE NBR       IF INFLOW
C                       =  FACE NBR       IF OUTFLOW
C                       =  0              IF NOFLOW

C  NONU IS 2 X NCOEF ARRAY HOLDING
C  NONU(1,N)=-NODE   ENTRY PERTAINS TO INFLOW FACE
C           = NODE   ENTRY PERTAINS TO OUTFLOW FACE, WHERE NODE IS THE 
C  EQUATION NUMBER ASSOCIATED WITH NONU ENTRY;
C  NONU(2,N)=BOUNDARY FACE NUMBER (INDEX INTO CBNDY) ASSOCIATED WITH 
C  NONU ENTRY.
C  EACH NONU ROW CORRESPONDS TO AN ENTRY IN THE VECTOR SAV, WHICH IS
C  CWGHT*VOLUME TO BE MULTIPLIED BY CONCENTRATION TO FORM A NEW TIME
C  LEVEL CONTRIBUTION TO THE RHS OF INTERIOR EQUATION NUMBER NODE.
C
C  BDYCL AND ELLCL BUILD NONU AND SAV EACH FIRST TRANSPORT TIME STEP
C  (IMOV=1) AND STORE THE NUMBER OF ENTRIES IN NCOEF. 
C
C  OUTFLOW BOUNDARY CONCENTRATIONS CAN CHANGE EACH TRANSPORT TIME STEP,
C  SO ELLOUT MUST ALWAYS BE CALLED, AFTER ALL MASS TRACKING FOR THE 
C  TIME STEP HAS BEEN COMPLETED (AFTER BDYINT AND ELLLHI CALLED FROM
C  MAIN).  
C
C  INFLOW BOUNDARY CONCENTRATIONS ARE OBTAINED FROM CBNDY.  INFLOW
C  CONCENTRATIONS ARE INITIALIZED TO CONCENTRATIONS AT CELL CENTER
C  (MOC5), THEN UPDATED TO THE (CONSTANT OVER FLOW TIME STEP) CINFL/RF
C  VALUES BY ELIUPD.  FOR MASS BALANCE TO WORK PROPERLY, THIS 
C  SUBROUTINE MUST BE CALLED BEFORE ELIUPD AT THE FIRST TRANSPORT TIME
C  STEP, SO THAT CBNDY STILL HAS INITIAL (OLD TIME LEVEL) VALUES FOR
C  INFLOW CONCENTRATION.
C**********************************************************************
C
       DO N=1,NFACES
          IF (IDBNDY(N).GT.0)
     *        CBNDY(IDBNDY(N))=RHSO(IDBNDY(N))/DIAGO(IDBNDY(N))
c                  
          if (IDBNDY(N).GT.0) then
cgzh           if (DIAGO(IDBNDY(N)).le.PRECNO)
           if (DIAGO(IDBNDY(N)).le.0.0) then
          print *,'ellout divide by zero',
     *     RHSO(IDBNDY(N)),'/',DIAGO(IDBNDY(N)),n,IDBNDY(N)
                stop
            end if
          endif
c
       ENDDO
      IF (NRFLG.EQ.1) RETURN
C
      DO 200 N=1,NCOEF
      NODE=NONU(1,N)
C      
C   EACH ENTRY IS FOR INFLOW OR FOR OUTFLOW
C   IF ENTRY IS FOR INFLOW, NODE IS STORED AS NEGATIVE
C
c******************************************************************      
c  this is old, and replaced with next two lines. delete this.
c
c      IF (NODE) 10,10,20
C
C   INFLOW MASS
C
c10    NODE=-NODE
c      BMAS=CBNDY(NONU(2,N))*SAV(N)
c      GOTO 30
C
C   OUTFLOW MASS
C
c20    BMAS=CBNDY(NONU(2,N))*SAV(N)
C
c30    CONTINUE
c*******************************************************************
      NODE=ABS(NODE)
cgzh add ibound check (need to convert j from js etc, might need MOC common block)
      BMAS=CBNDY(NONU(2,N))*SAV(N)
      RHS(NODE)=RHS(NODE)-BMAS
C       
C   ACCUMULATE MASS REPRESENTED BY BNDY NODE FOR MASS BALANCE
C
      CBE = BMAS*POR(NODE)
      STMASS = STMASS + CBE
      IF (JRF.EQ.1) THEN
         JS = MOD(NODE-1,NSCOL)+1
         KS = (NODE -1)/(NSCOL*NSROW) + 1
         IS = (NODE-JS)/NSCOL-(KS-1)*NSROW+1
         ADMASS = ADMASS + CBE*RF(JS,IS,KS) - CBE
      ENDIF
C      
200   CONTINUE
C
      RETURN
      END
C
C*************************************************************************
C
      SUBROUTINE ELNUPD(CBNDY,LBNDY,
     *    CONC,NODESS,NTFACE,NFACES,NSCOL,NSROW,NSLAY)
C
C**********************************************************************
C  MOVE NOFLOW BOUNDARY CONCENTRATIONS TO SOLUTION VECTOR
C
C  ELNUPD USES LBNDY TABLE TO DETERMINE WHICH BOUNDARY FACES ARE 
C  NOFLOW, AND USES THE ASSOCIATED CELL CENTER NODE NUMBER STORED IN
C  LBNDY FOR NOFLOW FACES TO UPDATE THE CBNDY ENTRY WITH CURRENT
C  CONCENTRATION AT INTERIOR NODE.
C**********************************************************************
      DIMENSION CBNDY(NTFACE),LBNDY(NTFACE),CONC(NODESS)
      COMMON /SUBGRD/ ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,
     *  ISLAY2,ISUBGD
C**********************************************************************
C   FOR EACH BOUNDARY FACE,
C      LBNDY(FACE NBR)= -1       IF INFLOW            (CTCFLO>0)
C                     =  0       IF OUTFLOW           (CTCFLO<0)
C                     =CELL CENTER NODE NBR    IF NOFLOW
C                                        (CTCFLO=0, OR NO CTCFLO ENTRY)
C                     = -2       IF FACE OF INACTIVE CELL
C**********************************************************************
C
      DO 100 N=1,NTFACE
        IF (LBNDY(N).GT.0) CBNDY(N)=CONC(LBNDY(N))
100   CONTINUE
   
      RETURN 
      END
C
C**********************************************************************
C     ELIUPD
C**********************************************************************
C
      SUBROUTINE ELIUPD(CBNDY,IDBNDY,CTCFLO,LOCBDY,CINFL,NCINFL,RF,
     * IABOVE,IBELOW,CONC,NODESS,NTFACE,NFACES,NSCOL,NSROW,NSLAY,
     * NCOL,NROW)
C
C***********************************************************************
C   MOVE INFLOW BOUNDARY CONCENTRATIONS TO SOLUTION VECTOR
C
C   AT THE FIRST TRANSPORT TIME STEP, ELIUPD UPDATES INFLOW FACE 
C   ENTRIES IN CBNDY WITH INFLOW CONCENTRATIONS FROM CINFL.
C   ELIUPD MUST BE CALLED BEFORE ELLOUT FOR MASS BALANCE TO WORK
C   PROPERLY.
C***********************************************************************
C
      DIMENSION CBNDY(NTFACE),IDBNDY(NFACES),CTCFLO(NFACES),
     *          LOCBDY(3,NFACES),CINFL(NCINFL),RF(NSCOL,NSROW,NSLAY),
     *          CONC(NODESS)
      COMMON /SUBGRD/ ISCOL1,ISCOL2,ISROW1,ISROW2,ISLAY1,
     *  ISLAY2,ISUBGD
      COMMON /ELLAM/ CINV,RINV,BINV,HCINV,HRINV,HBINV,
     *               STINIT,ADINIT,STMASS,ADMASS,OLMASS,
     *               AZERO,
     *               NSC,NSR,NSL,NT,NCTF,NRTF,NLTF,
     *               NEIGHB(8,2),NSLOPE(3),
     *               IDTOP,IDMAX,NCOEF,NSCH,NSRH,NSLH
C
C
      DO 200 ID=1,NFACES
        IF (IDBNDY(ID).LT.0) THEN
          J=LOCBDY(1,ID)
          I=LOCBDY(2,ID)
          K=LOCBDY(3,ID)

C   DISOLVED SOLUTE CONCENTRATION ON BNDY IS CINFL/RF
C   IDTOP STORED IN ELLAM.INC BY SMOC5BY
          IF (ID.LT.IDTOP) THEN
            KS=K-ISLAY1+1
            CPRIME=CINFL(KS)
          ELSE
            IF (NSROW.EQ.NROW.AND.NSCOL.EQ.NCOL) THEN       ! Added by YCLin
               NNSLAY = 0                                   !       :
            ELSE IF (NSROW.NE.NROW.OR.NSCOL.NE.NCOL) THEN   !       :
               NNSLAY = NSLAY                               !       :
            END IF                                          !       :
            CPRIME=0.0
            IF (MOD(ID,2).EQ.0) THEN
              IF (IABOVE.EQ.0.AND.IBELOW.EQ.1)
     *                CPRIME=CINFL(NNSLAY+1)
              IF (IABOVE.EQ.1.AND.IBELOW.EQ.1)
     *                CPRIME=CINFL(NNSLAY+2)
            ELSE
              IF (IABOVE.EQ.1) CPRIME=CINFL(NNSLAY+1)
            END IF
          END IF
          CBNDY(-IDBNDY(ID))=CPRIME
        ENDIF
200   CONTINUE        
C
C*************************************************************************
C
      RETURN
      END
C
